UNIT UI_EventHandler;
{$mode objfpc}{$H+}
INTERFACE
USES
    Classes
  , Sysutils
  , Forms
  , Controls
  , Graphics
  , Dialogs
  , ExtCtrls
  , StdCtrls
  , DB
  , ZConnection
  , ZDataset
  , UMC_cl_DAO_Extract
  ;

TYPE

  { Tform1 }

  Tform1 = CLASS ( Tform )
    BTN_Open: Tbutton;
    BTN_Close: Tbutton;
    Datasource1: Tdatasource;
    Panel1: Tpanel;
    Zconnection1: Tzconnection;
    Ztable1: Tztable;
    PROCEDURE Btn_closeclick ( Sender: Tobject ) ;
    PROCEDURE Btn_openclick ( Sender: Tobject ) ;
    PROCEDURE Formactivate ( Sender: Tobject ) ;
    PROCEDURE Formcreate ( Sender: Tobject ) ;
    PROCEDURE Formdestroy ( Sender: Tobject ) ;
  Private
    mo_Dao : TCL_DAO_Core;
    PROCEDURE  evthdl_Open_1( Sender : TObject );
    PROCEDURE  evthdl_Open_2( Sender : TObject );
    PROCEDURE  evthdl_Close_1( Sender : TObject );
    PROCEDURE  evthdl_Close_2( Sender : TObject );
  Public

  END;

VAR
  Form1: Tform1;

IMPLEMENTATION

{$R *.lfm}

{ Tform1 }

PROCEDURE Tform1.Formcreate ( Sender: Tobject ) ;
BEGIN
  Zconnection1.Database := 'Z:\DataBase\Projects\MusicCollection\Music.db';
  Zconnection1.LibraryLocation := 'Z:\DataBase\SQLite\sqlite3_64.dll';
  ZTable1.TableName := 'Band';

  mo_Dao := TCL_DAO_Core.Create( Datasource1, Ztable1 );
  mo_Dao.ON_Open := @evthdl_Open_1;
  mo_Dao.ON_Open := @evthdl_Open_2;
  mo_Dao.ON_Close := @evthdl_Close_1;
  mo_Dao.ON_Close := @evthdl_Close_2;
//
End;

PROCEDURE Tform1.Formdestroy ( Sender: Tobject ) ;
BEGIN
//
End;

PROCEDURE Tform1.Formactivate ( Sender: Tobject ) ;
BEGIN
//
End;

PROCEDURE Tform1.Btn_openclick ( Sender: Tobject ) ;
BEGIN
  Zconnection1.Connected := True;
  BTN_Close.Enabled := True;
  BTN_Open.Enabled := False;
  mo_Dao.Open;
End;


PROCEDURE Tform1.Btn_closeclick ( Sender: Tobject ) ;
BEGIN
  Zconnection1.Connected := False;
  BTN_Close.Enabled := False;
  BTN_Open.Enabled := True;
  mo_Dao.Close;
End;


PROCEDURE Tform1.evthdl_Open_1( Sender : TObject );
BEGIN
  showmessage( 'After Open 1' );
END;


PROCEDURE Tform1.evthdl_Open_2( Sender : TObject );
BEGIN
  showmessage( 'After Open 2' );
END;


PROCEDURE Tform1.evthdl_Close_1( Sender : TObject );
BEGIN
  showmessage( 'After Close 1' );
END;



PROCEDURE Tform1.evthdl_Close_2( Sender : TObject );
BEGIN
  showmessage( 'After Close 2' );
END;




END.

