UNIT UMC_cl_EventHandler_OBJ;
{$mode ObjFPC}{$H+}
INTERFACE
USES
    Classes
  , Sysutils
  , db
  ;

TYPE
  TEVT_Type = ( evt_Open, evt_Close, evt_DataChange, evt_StateChange );

TYPE
  TCL_EventHandler_OBJ = CLASS( TObject )
    PRIVATE { Attribute }
      mv_EvtType        : TEVT_Type;

    PRIVATE { Objecte }
      mo_EVT_Notify     : TNotifyEvent;
      mo_EVT_DataChange : TDataChangeEvent;
      mo_EVT_DataSet    : TDataSetNotifyEvent;

    PRIVATE { Event-Handler }

    PRIVATE { SET'ter}
      PROCEDURE   INIT_Self;

    PRIVATE { GET'ter}
      FUNCTION    sGET_Name : String;

    PROTECTED { Functions }
    PROTECTED { Procedures }
    PROTECTED { Event-Handler }
    PROTECTED { Property's }

    PUBLIC
      CONSTRUCTOR Create( iv_EVTType : TEVT_Type; io_Evt : TNotifyEvent );
      CONSTRUCTOR Create( iv_EVTType : TEVT_Type; io_Evt : TDataChangeEvent );
      CONSTRUCTOR Create( iv_EVTType : TEVT_Type; io_Evt : TDataSetNotifyEvent );
      DESTRUCTOR  Destroy;                                                                          OVERRIDE;
    PUBLIC { Functions }
    PUBLIC { Procedures }
      PROCEDURE   CALL_Handler( Sender, Field : TObject );

    PUBLIC { Event-Handler }
    PUBLIC { Property's }
      PROPERTY    EVTHDL_Notify : TNotifyEvent
                  READ  mo_EVT_Notify;

      PROPERTY    EVTHDL_DataChange : TDataChangeEvent
                  READ  mo_EVT_DataChange;

      PROPERTY    EVTHDL_DataSet : TDataSetNotifyEvent
                  READ  mo_EVT_DataSet;

      PROPERTY    EVT_Type : TEVT_Type
                  READ  mv_EvtType;

      PROPERTY    Name : String
                  READ  sGET_Name;
  END;



IMPLEMENTATION


{===================================================================================================
===================================================================================================}
CONSTRUCTOR TCL_EventHandler_OBJ.Create( iv_EVTType : TEVT_Type; io_Evt : TNotifyEvent );
BEGIN
  INHERITED Create;
  INIT_Self;
  mv_EvtType    := iv_EVTType;
  mo_EVT_Notify := io_Evt;
END;


{===================================================================================================
===================================================================================================}
CONSTRUCTOR TCL_EventHandler_OBJ.Create( iv_EVTType : TEVT_Type; io_Evt : TDataChangeEvent );
BEGIN
  INHERITED Create;
  INIT_Self;
  mv_EvtType    := iv_EVTType;
  mo_EVT_DataChange := io_Evt;
END;


{===================================================================================================
===================================================================================================}
CONSTRUCTOR TCL_EventHandler_OBJ.Create( iv_EVTType : TEVT_Type; io_Evt : TDataSetNotifyEvent );
BEGIN
  INHERITED Create;
  INIT_Self;
  mv_EvtType    := iv_EVTType;
  mo_EVT_DataSet := io_Evt;
END;



{===================================================================================================
===================================================================================================}
DESTRUCTOR TCL_EventHandler_OBJ.Destroy;
BEGIN
  INHERITED Destroy;
END;


{===================================================================================================
===================================================================================================}
PROCEDURE TCL_EventHandler_OBJ.INIT_Self;
BEGIN
  mo_EVT_Notify     := NIL;
  mo_EVT_DataChange := NIL;
  mo_EVT_DataSet    := NIL;
END;


{===================================================================================================
===================================================================================================}
FUNCTION TCL_EventHandler_OBJ.sGET_Name : String;
BEGIN
  Result := InttoStr( integer( mv_EvtType ) )
END;


{===================================================================================================
===================================================================================================}
PROCEDURE TCL_EventHandler_OBJ.CALL_Handler( Sender, Field : TObject );
BEGIN
  IF Assigned( EVTHDL_Notify ) THEN BEGIN
    EVTHDL_Notify( Sender );
    EXIT;
  END;

  IF Assigned( EVTHDL_DataChange ) THEN BEGIN
    EVTHDL_DataChange( Sender, Field AS TField );
    EXIT;
  END;

  IF Assigned( EVTHDL_DataSet ) THEN BEGIN
    EVTHDL_DataSet( Sender AS TDataSet );
    EXIT;
  END;

END;



END.

